
 #include<fstream.h>
 #include<conio.h>
 #include<graphics.h>
 #include<dos.h>
 #include<stdlib.h>
 #include<string.h>

   enum SIDE {LEFT,RIGHT};
   enum POSITION{STAND,LEAN,KO,WIN};
   enum PUNCH{NOPUNCH,LEFTJAB,RIGHTJAB,UPPERCUT,LHOOK,RHOOK};
   enum HIT{NOTHIT,FACEHIT,STOMACHHIT};

 class box
 {
   int x,y,angle;

  public:
  void jab(int x,int y,int angle,COLORS c)
  {
   setcolor(c);
   setfillstyle(1,c);
   fillellipse(x,y,10,12);
   setfillstyle(1,WHITE);
   pieslice(x,y,angle-45,angle+90,10);
  }
  void uppercut(int x,COLORS c)
  {
    setcolor(c);
    setfillstyle(1,c);
    fillellipse(x,255,10,12);
    setfillstyle(1,WHITE);
    pieslice(x,y,30,150,10);
  }
  void lhook(int x,POSITION p,COLORS c)
  {
   if(p==STAND)
   {
    setcolor(c);
    setfillstyle(1,c);
    fillellipse(x,258,8,10);
    setfillstyle(1,WHITE);
    fillellipse(x,258,7,5);
    sound(80);
    delay(30);
    setcolor(c);
    setfillstyle(1,c);
    fillellipse(x,258,12,15);
    setfillstyle(1,WHITE);
    fillellipse(x,258,10,8);
    delay(20);
    nosound();
   }
   if(p==LEAN)
   {
    setcolor(c);
    setfillstyle(1,c);
    fillellipse(x,298,8,10);
    setfillstyle(1,WHITE);
    fillellipse(x,298,7,5);
    sound(30);
    delay(30);
    setcolor(c);
    setfillstyle(1,c);
    fillellipse(x,298,12,15);
    setfillstyle(1,WHITE);
    fillellipse(x,298,10,8);
    delay(20);
    nosound();
   }
  }
  void star(int x,int y)
  {
   int a[26];
   a[0]=x;
   a[1]=y-20;
   a[2]=x+7;
   a[3]=y-10;
   a[4]=x+17;
   a[5]=y-10;
   a[6]=x+12;
   a[7]=y;
   a[8]=x+17;
   a[9]=y+10;
   a[10]=x+7;
   a[11]=y+10;
   a[12]=x;
   a[13]=y+20;
   a[14]=x-7;
   a[15]=y+10;
   a[16]=x-17;
   a[17]=y+10;
   a[18]=x-12;
   a[19]=y;
   a[20]=x-17;
   a[21]=y-10;
   a[22]=x-7;
   a[23]=y-10;
   a[24]=a[0];
   a[25]=a[1];
   setfillstyle(1,5);
   fillpoly(13,a);
  }
 };

 class boxer:public box
 {
   int x;
   COLORS c;
   SIDE side;
   POSITION p;
   PUNCH punch;
   HIT hit;
  public:

   boxer(int xCo,int cl,int s)
   {
    x=xCo;
    c=cl;
    side=s;
    p=STAND;
    punch=NOPUNCH;
    hit=NOTHIT;
   }
   void inx(int xx)
   {
    x=xx;
   }
   int outx(void)
   {
    return x;
   }
   void setp(POSITION pp)
   {
    p=pp;
   }
   POSITION getp(void)
   {
    return p;
   }
   void sethit(HIT h)
   {
    hit=h;
   }
   void setpunch(PUNCH p)
   {
    punch=p;
   }
   void sets(SIDE s)
   {
    side=s;
   }
   SIDE gets(void)
   {
    return side;
   }
   void head(int x,int y,SIDE s,COLORS c)
   {
    setfillstyle(1,12);
    fillellipse(x,y,10,15);
    setfillstyle(1,c);
    if(s==LEFT)
    {
     bar(x-10,y-12,x,y+5);
     bar(x,y-12,x+10,y-5);
    }
    else
    {
     bar(x-10,y-12,x,y-5);
     bar(x,y-12,x+10,y+5);
    }
   }
   void limb(int x1,int y1,int x2,int y2)
   {
     line(x1-4,y1,x2-4,y2);
     line(x1-1,y1,x2-1,y2);
     line(x1+1,y1,x2+1,y2);
     line(x1+4,y1,x2+4,y2);
   }
   void lower(int x,SIDE s,COLORS c)
   {
    if(p!=KO)
    {
     setfillstyle(1,c);
     bar(x-10,310,x+10,330);
     setfillstyle(1,12);//12=>light red
     if(s==LEFT)
     {
      bar(x-10,331,x,360);
      setlinestyle(SOLID_LINE,1,3);setcolor(12);
      limb(x-5,360,x-50,400);
      limb(x+5,331,x+30,360);
      bar(x+26,360,x+35,400);
     }
     else
     {
      bar(x,331,x+10,360);
      setlinestyle(SOLID_LINE,1,3);setcolor(12);
      limb(x+5,360,x+50,400);
      limb(x-5,331,x-30,360);
      bar(x-26,360,x-35,400);
     }
    }
    else
    {
     if(s==LEFT)
     {
      setfillstyle(1,c);
      bar(x-70,375,x-40,400);
      bar(x-145,380,x-150,400);
      setfillstyle(1,12);//12=>light red
      bar(x-40,390,x,400);
      setlinestyle(SOLID_LINE,1,3);setcolor(12);
      limb(x-40,390,x-15,360);
      limb(x-15,361,x+10,400);
     }
     else
     {
      setfillstyle(1,c);
      bar(x+70,375,x+40,400);
      bar(x+145,380,x+150,400);
      setfillstyle(1,12);//12=>light red
      bar(x+40,390,x,400);
      setlinestyle(SOLID_LINE,1,3);setcolor(12);
      limb(x+40,390,x+15,360);
      limb(x+15,361,x-10,400);
     }
    }
   }
   void upper(int x,SIDE side,POSITION p,COLORS c)
   {
    if((p==STAND)&&(hit==NOTHIT))
    {
     if(punch==NOPUNCH)
     {
      setfillstyle(1,c);
      fillellipse(x,285,15,30);
      setfillstyle(1,12);
      fillellipse(x,275,10,15);
      if(side==LEFT)
      {
       head(x+10,250,side,c);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x,280,x+15,305);
       limb(x+15,305,x+30,280);
       limb(x+27,305,x+42,280);
       box::jab(x+41,268,45,c);
       box::jab(x+30,268,45,c);
      }
      else
      {
       head(x-10,250,side,c);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x,280,x-15,305);
       limb(x-15,305,x-30,280);
       limb(x-27,305,x-42,280);
       box::jab(x-41,268,90,c);
       box::jab(x-30,268,90,c);
      }
     }
     if(punch==LEFTJAB)
     {
      setfillstyle(1,c);
      fillellipse(x,285,15,30);
      setfillstyle(1,12);
      fillellipse(x,275,10,15);
      if(side==LEFT)
      {
       head(x+10,250,side,c);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x,280,x+15,305);
       limb(x+15,305,x+30,280);
       setfillstyle(1,12);
       bar(x+15,255,x+100,265);
       box::jab(x+105,260,29,c);
       box::jab(x+30,268,45,c);
      }
      else
      {
       head(x-10,250,side,c);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x,280,x-15,305);
       limb(x-15,305,x-30,280);
       setfillstyle(1,12);
       bar(x-15,255,x-100,265);
       box::jab(x-105,260,135,c);
       box::jab(x-30,268,90,c);
      }
      sound(50);
      delay(100);
      nosound();
      punch=NOPUNCH;
     }
     if(punch==RIGHTJAB)
     {
      setfillstyle(1,c);
      fillellipse(x,285,15,30);
      setfillstyle(1,12);
      fillellipse(x,275,10,15);
      if(side==LEFT)
      {
       head(x+10,250,side,c);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x+17,305,x+40,280);
       box::jab(x+40,268,45,c);
       setfillstyle(1,12);
       bar(x,265,x+105,275);
       box::jab(x+115,268,29,c);
      }
      else
      {
       head(x-10,250,side,c);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x-17,305,x-40,280);
       box::jab(x-40,268,90,c);
       setfillstyle(1,12);
       bar(x,265,x-105,275);
       box::jab(x-115,268,135,c);
      }
      sound(50);
      delay(100);
      nosound();
      punch=NOPUNCH;
     }
     if(punch==LHOOK)
     {
      if(side==LEFT)
      {
       setfillstyle(1,c);
       fillellipse(x+4,285,18,30);
       setfillstyle(1,12);
       fillellipse(x,275,10,15);
       head(x+13,250,side,c);
       setlinestyle(SOLID_LINE,1,3);setcolor(12);
       limb(x,280,x+15,305);
       limb(x+15,305,x+30,280);
       setfillstyle(1,12);
       bar(x+18,255,x+50,265);
       box::jab(x+30,268,45,c);
       box::lhook(x+60,STAND,c);
      }
      else
      {
       setfillstyle(1,c);
       fillellipse(x-4,285,18,30);
       setfillstyle(1,12);
       fillellipse(x,275,10,15);
       head(x-13,250,side,c);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x,280,x-15,305);
       limb(x-15,305,x-30,280);
       setfillstyle(1,12);
       bar(x-18,255,x-50,265);
       box::jab(x-30,268,135,c);
       box::lhook(x-60,STAND,c);
      }
     }
     punch=NOPUNCH;
    }
    if((p==STAND)&&(hit==FACEHIT))
    {
      setfillstyle(1,c);
      fillellipse(x,285,15,30);
      setfillstyle(1,12);
      fillellipse(x,275,10,15);
      if(side==LEFT)
      {
       head(x-5,250,side,c);  star(x+10,260);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x,280,x+15,305);
       limb(x+15,305,x+30,280);
       limb(x+27,305,x+42,280);
       box::jab(x+41,268,45,c);
       box::jab(x+30,268,45,c);
       delay(50);
      }
      else
      {
       head(x+5,250,side,c); star(x-10,260);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x,280,x-15,305);
       limb(x-15,305,x-30,280);
       limb(x-27,305,x-42,280);
       box::jab(x-41,268,90,c);
       box::jab(x-30,268,90,c);
       delay(50);
      }
     hit=NOTHIT;
    }
    if((p==STAND)&&(hit==STOMACHHIT))
    {
      setfillstyle(1,c);
      fillellipse(x,285,10,30);
      setfillstyle(1,12);
      fillellipse(x,275,10,15);   star(x,290);
      if(side==LEFT)
      {
       head(x+12,250,side,c);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x,280,x+15,305);
       limb(x+15,305,x+30,280);
       limb(x+27,305,x+42,280);
       box::jab(x+41,268,45,c);
       box::jab(x+30,268,45,c);
       delay(50);
      }
      else
      {
       head(x-12,250,side,c);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x,280,x-15,305);
       limb(x-15,305,x-30,280);
       limb(x-27,305,x-42,280);
       box::jab(x-41,268,90,c);
       box::jab(x-30,268,90,c);
       delay(50);
      }
     hit=NOTHIT;
    }

    if((p==LEAN)&&(hit==NOTHIT))
    {
     if(punch==NOPUNCH)
     {
      if(side==LEFT)
      {
       setfillstyle(1,c);
       fillellipse(x+20,300,30,15);
       setfillstyle(1,12);
       fillellipse(x+15,300,15,10);
       head(x+45,290,side,c);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x+20,300,x+35,325);
       limb(x+35,325,x+65,300);
       limb(x+47,325,x+82,300);
       box::jab(x+81,295,45,c);
       box::jab(x+70,295,45,c);
      }
      else
      {
       setfillstyle(1,c);
       fillellipse(x-20,300,30,15);
       setfillstyle(1,12);
       fillellipse(x-15,300,15,10);
       head(x-45,290,side,c);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x-20,300,x-35,325);
       limb(x-35,325,x-65,300);
       limb(x-47,325,x-82,300);
       box::jab(x-81,295,90,c);
       box::jab(x-70,295,90,c);
      }
     }
     if(punch==LEFTJAB)
     {
      if(side==LEFT)
      {
       setfillstyle(1,c);
       fillellipse(x+18,300,30,15);
       setfillstyle(1,12);
       fillellipse(x+14,300,14,10);
       head(x+43,290,side,c);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x+20,300,x+35,325);
       limb(x+35,325,x+65,300);
       setfillstyle(1,12);
       bar(x+105,300,x+85,310);
       box::jab(x+65,295,45,c);
       box::jab(x+115,305,45,c);
      }
      else
      {
       setfillstyle(1,c);
       fillellipse(x-18,300,30,15);
       setfillstyle(1,12);
       fillellipse(x-14,300,14,10);
       head(x-43,290,side,c);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x-20,300,x-35,325);
       limb(x-35,325,x-65,300);
       setfillstyle(1,12);
       bar(x-105,300,x-85,310);
       box::jab(x-65,295,90,c);
       box::jab(x-115,305,90,c);
      }
      sound(80);
      delay(50);
      nosound();
     }
     if(punch==RIGHTJAB)
     {
      if(side==LEFT)
      {
       box::jab(x+40,310,45,c);
       limb(x+27,325,x+40,300);
       setfillstyle(1,c);
       fillellipse(x+18,300,30,15);
       setfillstyle(1,12);
       fillellipse(x+14,300,14,10);
       head(x+43,290,side,c);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       setfillstyle(1,12);
       bar(x+25,290,x+100,300);
       box::jab(x+110,295,29,c);
      }
      else
      {
       box::jab(x-40,300,90,c);
       limb(x-27,325,x-40,300);
       setfillstyle(1,c);
       fillellipse(x-18,300,30,15);
       setfillstyle(1,12);
       fillellipse(x-14,300,14,10);
       box::jab(x-110,295,135,c);
       head(x-43,290,side,c);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       setfillstyle(1,12);
       bar(x-25,290,x-100,300);
      }
      sound(80);
      delay(50);
      nosound();
     }
     if(punch==LHOOK)
     {
      if(side==LEFT)
      {
       setfillstyle(1,c);
       fillellipse(x+18,300,30,15);
       setfillstyle(1,12);
       fillellipse(x+14,300,14,10);
       head(x+43,290,side,c);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x+20,300,x+35,325);
       limb(x+35,325,x+65,300);
       setfillstyle(1,12);
       bar(x+45,300,x+85,310);
       box::jab(x+65,295,45,c);
       box::lhook(x+95,LEAN,c);
      }
      else
      {
       setfillstyle(1,c);
       fillellipse(x-18,300,30,15);
       setfillstyle(1,12);
       fillellipse(x-14,300,14,10);
       head(x-43,290,side,c);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x-20,300,x-35,325);
       limb(x-35,325,x-65,300);
       setfillstyle(1,12);
       bar(x-45,300,x-85,310);
       box::jab(x-65,295,45,c);
       box::lhook(x-95,LEAN,c);
      }
     }
     punch=NOPUNCH;
    }
    if((p==LEAN)&&(hit==STOMACHHIT))
    {
      if(side==LEFT)
      {
       setfillstyle(1,c);
       fillellipse(x+20,300,25,15);
       setfillstyle(1,12);
       fillellipse(x+15,300,15,10);
       head(x+40,290,side,c); star(x+30,315);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x+20,300,x+30,325);
       limb(x+35,325,x+65,300);
       limb(x+47,325,x+82,300);
       box::jab(x+81,295,45,c);
       box::jab(x+70,295,45,c);
       delay(50);
      }
      else
      {
       setfillstyle(1,c);
       fillellipse(x-20,300,25,15);
       setfillstyle(1,12);
       fillellipse(x-15,300,15,10);
       head(x-40,290,side,c);       star(x-30,315);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x-20,300,x-35,325);
       limb(x-35,325,x-65,300);
       limb(x-47,325,x-82,300);
       box::jab(x-81,295,90,c);
       box::jab(x-70,295,90,c);
       delay(50);
      }
     hit=NOTHIT;
    }
    if(p==WIN)
    {
      setfillstyle(1,c);
      fillellipse(x,285,17,30);
      setfillstyle(1,12);
      fillellipse(x,275,10,15);
      if(side==LEFT)
      {
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x+17,255,x+20,230);
       head(x+8,245,side,c);
       limb(x,280,x-15,255);
       limb(x-15,255,x-17,230);
       box::jab(x+19,220,60,c);
       box::jab(x-17,220,60,c);
      }
      else
      {
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x-17,255,x-20,230);
       head(x-8,245,side,c);
       limb(x,280,x+15,255);
       limb(x+15,255,x+17,230);
       box::jab(x-19,220,135,c);
       box::jab(x+17,220,135,c);
      }
    }
    if(p==KO)
    {
      if(side==LEFT)
      {
       setfillstyle(1,c);
       fillellipse(x-100,390,30,15);
       setfillstyle(1,12);
       fillellipse(x-115,390,15,10);
       fillellipse(x-140,390,15,10);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x-100,400,x-75,390);
       //head(x-18,385,side,c);
       limb(x-75,390,x-55,370);
       //limb(x-15,255,x-17,230);
       box::jab(x-55,360,60,c);
       box::jab(x-100,375,60,c);
      }
      else
      {
       setfillstyle(1,c);
       fillellipse(x+100,390,30,15);
       setfillstyle(1,12);
       fillellipse(x+115,390,15,10);
       fillellipse(x+140,390,15,10);
       setlinestyle(SOLID_LINE,1,3);
       setcolor(12);
       limb(x+100,400,x+75,390);
       limb(x+75,390,x+55,370);
       box::jab(x+55,360,60,c);
       box::jab(x+100,375,60,c);
      }
    }

   }
   void display(void)
   {
    lower(x,side,c);
    upper(x,side,p,c);
   }
 };

 class wind
 {
  int l,t,r,b;
  char str[500];
  int color;
  public:
  wind()
  {
   l=5;
   t=7;
   r=75;
   b=21;
   color=2;
  }

  void text(char s[])
  {
   strcpy(str,s);
  }
  void draw();
  void erase()
  {
   window(l,t,r,b);
   clrscr();
  }
 };

 void wind::draw()
 {
  erase();
  window(l,t-1,r,b);
  int ww=r-l+1;
  int hh=b-t+1;
  textcolor(color);
  textbackground(BLUE);
  for(int j=1;j<=ww;j++)
  {
   gotoxy(j,1);putch(char(205));
   gotoxy(j,hh);putch(char(205));
  }
  for(j=1;j<=hh;j++)
  {
  gotoxy(1,j);putch(char(186));
  gotoxy(ww,j);putch(char(186));
  }
  gotoxy(1,1);putch(char(201));
  gotoxy(ww,1);putch(char(187));
  gotoxy(1,hh);putch(char(200));
  gotoxy(ww,hh);putch(char(188));
  window(l+2,t+1,r-2,b-3);
  cputs(str);
  window(l,t,r,b-1);
  gotoxy(3,hh-2);
  cputs("                                          press any key to continue");
  textcolor(8);
 }
 void ring(int pa,int pb)
 {
  setfillstyle(2,8);
  bar(0,80,640,300);
  settextstyle(4,0,3);
  outtextxy(310,38,"KO");
  settextstyle(4,0,2);
  outtextxy(150,61,"GIRINDAR");
  settextjustify(RIGHT_TEXT,TOP_TEXT);
  outtextxy(590,61,"COMPUTER");
  rectangle(10,30,210,60);
  setfillstyle(1,4);
  bar(210-pa,35,210,55);
  rectangle(430,30,630,60);
  bar(430+pb,35,430,55);
  setfillstyle(1,7);
  bar(0,300,640,400);
  setfillstyle(6,GREEN);
  bar(50,150,70,300);
  bar(570,150,590,300);
  setcolor(RED);
  setlinestyle(0,0,3);
  int k=20;
  for(int i=150;i<=300;i+=50)
  {
   line(50,i,0,i+k);
   line(50,i,590,i);
   line(590,i,640,i+k);
   k+=10;
  }
 }
 void main()
 {
   boxer a(200,4,LEFT),b(440,1,RIGHT);
   int temp,va=200,vb=200,xa=a.outx(),xb=b.outx();
   char c;
   enum BOOLEAN{FALSE,TRUE};
   BOOLEAN binary;
   POSITION pa=STAND,pb=STAND;
   PUNCH punch=NOPUNCH;
   fstream f;f.open("proj3.dat",ios::binary);

    clrscr();
    wind w;
    w.text("                   WELCOME TO THE BOXING GAME!                     THIS PROGRAM WAS COMPLETED BY GIRINDAR SINGH ROLL NO. (99/AT/IT/11)THIRD SEMESTER STUDENT IN AMITY SCHOOL OF ENGGINEERING & TECHNOLOGY                    COMPLETED ON NOVEMBER 29 2k                    ");
    w.draw();
    getch();
    w.erase();
    w.text("  \n\t a->LEFT \t s->RIGHT \t z->BEND/LEAN /t w->STAND \t f->LEFT JAB      \t g->RIGHT JAB \t h->HOOK \t q->QUIT");
    w.draw();
    getch();
    w.erase();
    window(1,1,80,25);

  int driver,mode;
  driver=DETECT;
  initgraph(&driver,&mode,"\\tc\\bgi");
    setbkcolor(7);
    ring(va,vb);
    a.display();
    b.display();
    settextstyle(4,0,6);
    outtextxy(550,150,"ARE YOU READY?");
    delay(3000);
    clrscr();
    ring(va,vb);
    a.display();
    b.display();
    settextstyle(4,0,6);
    outtextxy(400,150,"FIGHT!");
   do
   {
     b.setp(pb);
     c=getch();
     if(c=='s')
      xa+=30;
     if(c=='a')
      xa-=30;
     if(xa>500) xa=500;
     if(xa<100) xa=100;
     if((a.gets()==LEFT)&&(xb<(xa+10)))
     {
      a.sets(RIGHT);
      b.sets(LEFT);
      xa+=10;
      xb-=10;
     }
     if((a.gets()==RIGHT)&&(xb>(xa+10)))
     {
      a.sets(LEFT);
      b.sets(RIGHT);
      xa-=10;
      xb+=10;
     }

     a.inx(xa);
     if(c=='z')
      a.setp(LEAN);
     if(c=='w')
      a.setp(STAND);
      pb=random(2);
      b.setp(pb);

     f.write((char*)&a,sizeof (a));
     f.write((char*)&b,sizeof(b));
     temp=random(80);
     binary=random(2);
     if(binary)
      xb+=temp;
     else
      xb-=temp;
     if(xb>500)
      xb=500;
     if(xb<100)
      xb=100;
     b.inx(xb);
     switch(c)
     {
      case 'g' :a.setpunch(RIGHTJAB);
		if(abs(xa-xb)<120)
		{
		 if((b.getp()==STAND)&&(a.getp()==STAND))
		 b.sethit(FACEHIT);
		 if(a.getp()==LEAN)
		 b.sethit(STOMACHHIT);
		 vb-=10;
		}
		break;
      case 'f' :a.setpunch(LEFTJAB);
		if(abs(xa-xb)<110)
		{
		 if((b.getp()==STAND)&&(a.getp()==STAND))
		 b.sethit(FACEHIT);
		 if(a.getp()==LEAN)
		 b.sethit(STOMACHHIT);
		 vb-=10;
		}
		break;
      case 'h' :a.setpunch(LHOOK);
		if(abs(xa-xb)<70)
		{
		 if((b.getp()==STAND)&&(a.getp()==STAND))
		 b.sethit(FACEHIT);
		 if(a.getp()==LEAN)
		 b.sethit(STOMACHHIT);
		 vb-=20;
		}
		break;
     }
    punch=random(4);
    b.setpunch(punch);
    switch(punch)
    {
      case 2 :  if(abs(xa-xb)<120)
		{
		 if((b.getp()==STAND)&&(a.getp()==STAND))
		 a.sethit(FACEHIT);
		 if(b.getp()==LEAN)
		 a.sethit(STOMACHHIT);
		 va-=10;
		}
		break;
      case 1 :  if(abs(xa-xb)<110)
		{
		 if((b.getp()==STAND)&&(a.getp()==STAND))
		 a.sethit(FACEHIT);
		 if(b.getp()==LEAN)
		 a.sethit(STOMACHHIT);
		 va-=10;
		}
		break;
      case 3 :	if(abs(xa-xb)<70)
		{
		 if((b.getp()==STAND)&&(a.getp()==STAND))
		 a.sethit(FACEHIT);
		 if(b.getp()==LEAN)
		 a.sethit(STOMACHHIT);
		 va-=20;
		}
		break;
    }
     clrscr();
     ring(va,vb);
     b.display();
     a.display();
     f.read((char*)&a,sizeof(a));
     f.read((char*)&b,sizeof(b));
     clrscr();
     ring(va,vb);
     a.display();
     b.display();
   }while((c!='q')&&(va>=0)&&(vb>=0));

    if((va<0)&&(vb>=0))
    {
     a.setp(KO);
     b.setp(WIN);
    }
    if((va>=0)&&(vb<0))
    {
     a.setp(WIN);
     b.setp(KO);
    }
    if((va<0)&&(vb<0))
    {
     a.setp(KO);
     b.setp(KO);
    }
    clrscr();
    ring(va,vb);
    if((va<0)&&(vb>=0))
    {
     settextstyle(4,0,4);
     outtextxy(550,150,"THE WINNER IS COMPUTER");
    }
    if((va>=0)&&(vb<0))
    {
     settextstyle(4,0,4);
     outtextxy(550,150,"THE WINNER IS GIRINDAR");
    }
    if((va<0)&&(vb<0))
    {
     settextstyle(4,0,4);
     outtextxy(400,150,"DOUBLE KO");
    }
    a.display();
    b.display();
    delay(8000);
    getch();
  closegraph();
 }
